require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xvmscsicontroller',
  dscmeta_resource_friendly_name: 'xVMScsiController',
  dscmeta_resource_name: 'MSFT_xVMScsiController',
  dscmeta_module_name: 'xHyper-V',
  dscmeta_module_version: '3.13.0.0',
  docs: 'The DSC xVMScsiController resource type.
         Automatically generated from version 3.13.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_restartifneeded: {
      type: 'Optional[Boolean]',
      desc: 'Specifies if the VM should be restarted if needed for property changes. If not specified, it defaults to False.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_controllernumber: {
      type: "Enum['0', '1', '2', '3']",
      desc: 'Specifies the number of the SCSI controller whose status is to be controlled. If not specified, it defaults to 0.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_vmname: {
      type: 'String',
      desc: 'Specifies the name of the virtual machine whose SCSI controller status is to be controlled',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Specifies if the SCSI controller should exist or not. If not specified, it defaults to Present.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
